2005-10-20  Ken Raeburn  <raeburn@mit.edu>
	    Jeffrey Altman  <jaltman@mit.edu>

	* gss-server.c [!_WIN32]: Include port-sockets.h instead of the
	various network-related UNIX header files.
	(worker_bee): New function.
	(main): Use it.
	(max_threads): New variable.
	(thread_count, hMutex, hEvent) [_WIN32]: New variables.
	(InitHandles, CleanupHandles, WaitAndIncrementThreadCounter,
	DecrementAndSignalThreadCounter) [_WIN32]: New functions.
	(main) [_WIN32]: Accept new option -threads, and keep that many
	threads going.
	(usage) [_WIN32]: Document new option.

	* gss-client.c [!_WIN32]: Include assert.h.
	(max_threads): New variable.
	(service_name, server_host, msg, mechanism, port, use_file,
	gss_flags, min_stat, oid, mcount, ccount, auth_flag, wrap_flag,
	encrypt_flag, mic_flag, v1_format): Moved variables to top level
	from inside main.
	(worker_bee): New function, with call_server call moved from
	main.
	(main): Call it.
	(thread_count, hMutex, hEvent) [_WIN32]: New variables.
	(InitHandles, CleanupHandles, WaitAndIncrementThreadCounter,
	DecrementAndSignalThreadCounter) [_WIN32]: New functions.
	(main) [_WIN32]: Accept new option -threads, and keep that many
	threads going.
	(usage) [_WIN32]: Document new option.

	* gss-misc.c (send_token): Delete unused variable "len".

2004-03-08  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (MY_SUBDIRS): Deleted.

2003-02-26  Jeffrey Altman <jaltman@mit.edu>

    * gss-client.c: merge if (this) if (that) into if (this && that)

2004-02-10  Jeffrey Altman <jaltman@mit.edu>

    * gss-client.c: Remove extraneous parameters from 
      client_establish_context()

2004-02-06  Jeffrey Altman <jaltman@mit.edu>

    * Update usage() for gss-client

2004-02-06  Jeffrey Altman <jaltman@mit.edu>

    * Add new command line switches to the gss-client
      to support the use of GSS_C_SEQUENCE_FLAG or to 
      disable the use of either GSS_C_MUTUAL_FLAG or 
      GSS_C_REPLAY_FLAG

2004-01-31  Ken Raeburn  <raeburn@mit.edu>

	* gss-misc.c: Include sys/time.h or time.h, to get struct timeval
	declaration.

2004-01-30  Jeffrey Altman <jaltman@mit.edu>

    * gss-misc.c (read_all): Add call to select() so we don't block forever

    * gss-server.c (main): Add missing "export" parameter to second sign_server()

2003-01-08  Sam Hartman  <hartmans@mit.edu>

	* gss-misc.c (recv_token): Support reading 0 token flags as part of length

	* gss-client.c :  Support a -v1 argument meaning that no token flags are used,

	* gss-misc.c (send_token): If token flags are null, do not send them.

2002-12-30  Ken Raeburn  <raeburn@mit.edu>

	* gss-misc.c (send_token, recv_token): Open-code the math to send
	and receive the length as four bytes in network order, rather than
	using the first four bytes of a size_t.

2002-08-29  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Revert $(S)=>/ change, for Windows support.

2002-08-23  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Change $(S)=>/ and $(U)=>.. globally.

2002-06-13  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in ($(OUTPRE)gss-server.exe, $(OUTPRE)gss-server.exe):
	Use ws2_32.lib instead of wsock32.lib.

2002-04-30  Sam Hartman  <hartmans@mit.edu>

	* gss-server.c (server_establish_context): Same here.

	* gss-client.c (client_establish_context):  delete the context
	when it is non-null, not when it is null. 

2001-12-05  Ezra Peisach  <epeisach@mit.edu>

	* gss-client.c, gss-misc.c, gss-server.c: Cast buffer length to
	int in length argument for printf.

2001-11-19  Ezra Peisach  <epeisach@mit.edu>

	* gss-server.c (server_establish_context, sign_server): Ensure
	that memory blocks are only freed once.

2001-11-07  Ezra Peisach  <epeisach@mit.edu>

	* gss-misc.c (recv_token): Do not attempt to malloc 0 bytes.

2001-11-01  Sam Hartman  <hartmans@mit.edu>

	* gss-server.c  gss-client.c:  Only free buffers returned from
	GSSAPI using  gss_release_buffer

	* gss-client.c (client_establish_context): Trailing null should
	not be part of service name 

2001-10-09  Ken Raeburn  <raeburn@mit.edu>

	* gss-misc.c, gss-misc.h: Make prototypes unconditional.

2001-09-01  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (SRCS): Use srcdir.

2001-06-18  Ezra Peisach  <epeisach@mit.edu>

	* gss-client.c (parse_oid): Cast argument to isdigit() to int.

	* gss-server.c (sign_server): Cast argument to isspace() to int.

2001-05-15  Danilo Almeida  <dalmeida@mit.edu>

	* gss-server.c (usage): Fix usage info *again* to reflect that
	service_name is required.

Tue Sep 26 18:13:54 2000  Ezra Peisach  <epeisach@mit.edu>

	* gss-misc.c: Include <sys/socket.h> for prototype definitions. 

	* gss-client.c gss-server.c: Warning cleanups.

2000-02-11  Tom Yu  <tlyu@mit.edu>

	* README, gss-client.c, gss-misc.c, gss-misc.h, gss-server.c:
	Patches from jik to make gss-sample more versatile.

2000-01-31  Danilo Almeida  <dalmeida@mit.edu>

	* gss-client.c, gss-server.c, gss-misc.c: Include Windows headers
	instead of Unix headers under Windows.

	* gss-server.c (usage): Fix usage info to reflect that service_name is
	required.

	* gss-misc.c (read_all, write_all): Change write to send and read
	to recv for portability.
	(gettimeofday): Add an implementation of gettimeofday() for
	Windows.

	* Makefile.in: Build under Windows.

1999-10-26  Wilfredo Sanchez  <tritan@mit.edu>

	* Makefile.in: Clean up usage of CFLAGS, CPPFLAGS, DEFS, DEFINES,
	LOCAL_INCLUDES such that one can override CFLAGS from the command
	line without losing CPP search patchs and defines. Some associated
	Makefile cleanup.

Mon Dec 21 22:04:02 1998  Theodore Y. Ts'o  <tytso@mit.edu>

	* gss-server.c (test_import_export_context): Fix memory leak.

1998-11-13  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* configure.in: Removed and tests moved up to appl/configure.in

	* Makefile.in: Set the myfulldir and mydir variables (which are
		relative to buildtop and thisconfigdir, respectively.)
		Add a MY_SUBDIRS macro set to '.' to indicate that there
		are no subdirectories to be processed by the Makefile.

1998-10-24  Marc Horowitz  <marc@mit.edu>

	* gss-server.c (sign_server): fix the text heuristic to recognize
		whitespace as text.
	(main): clean up file descriptors properly after each
		connection.

	* gss-client.c (read_file): properly handle empty files

	* gss-client.c: (call_server): NUL-terminate the contents
		of non-empty files on the wire.
	
Wed Feb 18 15:27:32 1998  Tom Yu  <tlyu@mit.edu>

	* Makefile.in: Remove trailing slash from BUILDTOP.  Fix up
	BUILDTOP for new conventions.

Sat Feb 14 10:33:20 1998  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* configure.in: Remove USE_ANAME

Mon Feb  2 17:02:29 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* Makefile.in: Define BUILDTOP and thisconfigdir in the Makefile

Thu Sep 18 17:52:26 1997  Tom Yu  <tlyu@mit.edu>

	* configure.in: Replace USE_STRING_H with something more sane.

	* gss-server.c: Replace USE_STRING_H with something more sane.

Fri Jun  6 15:05:57 1997  Theodore Y. Ts'o  <tytso@mit.edu>

	* gss-server.c (server_establish_context): Rearrange server
		establish context loop to match with the
		draft-ietf-gssv2-cbind-04.txt suggestion --- always send
		the output token even in the case of an error, and call
		gss_delete_sec_context() if needed.

	* gss-client.c (client_establish_context): Check for error
		condition after sending the output token, if present.  In
		case of error, call delete_sec_context if necessary.

Wed Feb  5 20:25:57 1997  Tom Yu  <tlyu@mit.edu>

	* Makefile.in:
	* configure.in: Update to new program build procedure.

Fri Nov 22 15:48:02 1996  unknown  <bjaspan@mit.edu>

	* gss-client.c (connect_to_server): use sizeof instead of h_length
 	to determine number of bytes of addr to copy from DNS response
 	[krb5-misc/211]

Sun Oct 27 22:04:59 1996  Ezra Peisach  <epeisach@mit.edu>

	* configure.in: Add USE_GSSAPI_LIBRARY

	* Makefile.in (LOCAL_LIBRARIES): Remove as -lgssapi_rpc should
		come from configure.  

Mon Oct 21 20:03:53 1996  Theodore Y. Ts'o  <tytso@mit.edu>

	* gss-server.c: Re-added code to test import and export security
 		context.  Yes, yes, I know this isn't the best place to
 		have this test, but DO NOT REMOVE THIS TEST UNTIL WE HAVE
 		IT CODED ELSEWHERE.  Better slightly ugly sample server
 		code than untested (and broken) library code....  Add code
 		to print out the mechanism OID used by accept_sec_context.

	* gss-client.c: Add code to allow user to specify the mechanism
		OID that gss-client should use.

Wed Jun  5 00:08:32 1996  Theodore Y. Ts'o  <tytso@mit.edu>

	* gss-client.c (call_server): When reading in the test value from
 		a file, don't free free inbuf.value until after the last
 		place where we use it.

Wed Apr 17 20:54:37 1996  Marc Horowitz  <marc@mit.edu>

	* all files: integrated changes from OpenVision as of
	October 1995

Tue Mar 12 23:46:26 1996  Ken Raeburn  <raeburn@cygnus.com>

	* gss-server.c (timeval_subtract): Use old-style function
	definition.

Sun Mar  3 12:14:48 1996  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-server.c (test_import_export_context): Add second argument
		to gettimeofday.

Sat Mar  2 03:03:27 1996  Theodore Y. Ts'o  <tytso@dcl>

	* gss-server.c (sign_server): Do better import/export security
		checking.  If the received message to be signed is not
		printable (at least the first two characters are not),
		display the message in hex.  Print the hex values of the
		incoming and outcoming packets, for your information.

	* gss-misc.c (print_token, display_buffer): Two new tokens for
		displaying GSSAPI buffers, either has hex or as a
		printable string.

	* gss-client.c (call_server): Add option to support reading in the
		message to be signed from a file.

Wed Feb 28 11:42:26 1996  Theodore Y. Ts'o  <tytso@dcl>

	* gss-client.c (call_server): Get the nametype OID from
		gss_display_name, print it, and then release the nametype
		OID.  This tests gss_display_name()'s ability to return a
		valid nametype, which can then be freed successfully.

Tue Feb 27 17:26:15 1996  Ezra Peisach  (epeisach@kangaroo.mit.edu)

	* configure.in: Add USE_ANAME.

Wed Jan  3 21:55:30 1996  Theodore Y. Ts'o  <tytso@dcl>

	* gss-client.c (main, client_establish_context): If the -d flag is
		given to the client, then try to delegate credentials when
		establishing the context.

Thu Oct 12 11:15:28 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-misc.c (recv_token): When continuing partial read, decrease
		number of bytes to read.

Sun Oct  8 14:26:25 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-misc.c (recv_token): When looping for partial read from
		network, start reading in the middle of the token.

Wed Sep 27 18:36:06 1995  Theodore Y. Ts'o  <tytso@dcl>

	* gss-client.c (main): Set display_file to be stdout.

	* gss-server.c (main): Set display_file to 0 if using inetd;
		otherwise, set it to be stdout.

	* gss-misc.c (send_token, recv_token, display_status): If
	        display_file is null, don't set it to stderr; just don't
		print the log message instead.  Needed for inetd operation.

Sat Sep 16 03:34:59 1995  Theodore Y. Ts'o  <tytso@dcl>

	* gss-server.c (sign_server): Only try using gss_export_context
		and gss_import_context if the dov2 flag has been set.
		(server_establish_context): Make sure the client
		gss_name_t is released.
		(main): Add a -once option which causes the gss-server to
		exit after processing one client.  Allows purify to report
		memory leaks.

Thu Sep 14 22:44:44 1995  Theodore Y. Ts'o  <tytso@dcl>

	* gss-server.c (create_socket): add setsockopt SO_REUSEADDR so
		that the socket can be reused right away.

Mon Sep  4 14:19:03 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-misc.c: Either include stdlib.h or declare malloc.

	* configure.in: Check for stdlib.h

Thu Aug 31 11:35:07 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Add -DUSE_AUTOCONF_H and -DGSSAPI_V2 to enable usage
		of autoconf.h in gssapi.h and to enable V2 features in local
		modules.
	* gss-client.c, gss-server.c - Add -v2 switch to use V2 features.
		Clean up V2 argument changes.
	* gss-misc.c - Clean up V2 argument change.


Tue Aug 29 13:24:50 EDT 1995	Paul Park	(pjpark@mit.edu)
	* gss-{client,server}.c - Test gss_{ex,im}port_sec_context().


Fri Jul 7 15:41:47 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Remove all explicit library handling.
	* configure.in - Add KRB5_LIBRARIES.


Thu Jun 15 17:35:08 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Change explicit library names to -l<lib> form, and
		change target link line to use $(LD) and associated flags.
		Also, remove DBMLIB, it was not used.
        * configure.in - Add shared library usage check.

Sat Jun 10 19:06:03 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-misc.c (recv_token): Initialize local variable to 0.

Sat Jun 10 00:28:50 1995  Theodore Y. Ts'o  <tytso@dcl>

	* gss-misc.c (recv_token): Allow for partial reads while reading
		the token.

Fri Jun  9 18:26:50 1995    <tytso@rsx-11.mit.edu>

	* configure.in: Remove standardized set of autoconf macros, which
		are now handled by CONFIG_RULES.

Wed May 24 11:11:45 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* gss-client.c: Include string.h or strings.h

	* gss-server.c: Include string.h or strings.h

	* configure.in: Check for string.h

Mon May 22 15:41:33 EDT 1995	Paul Park	(pjpark@mit.edu)
	* gss-server.c	: (server_establish_context) Don't call gss_release_
			  buffer right after gss_accept_sec_context because
			  in the event that we choke, we lose the minor status

Fri Apr 28 15:30:00 1995  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in (gss-client): Use $(LD) instead of $(CC) so that we can
		do purify checking.

	* gss-server.c (main, sign_server): Make changes to allow
		gss-server to be fired out of inetd.  New options: -inetd
		and -logfile.  The -logfile allows the output of
		gss-server to be redirected to a file.

	* gss-misc.c (send_token, recv_token, display_status_1): Add
	        support for -logfile option.  If the external FILE
		*display_file is set, redirect error messages to
		display_file instead of stderr.

Wed Apr 26 17:17:22 1995  Mark Eichin  <eichin@cygnus.com>

	* configure.in: use AC_CONST since we don't learn it from the krb5
	headers and gssapi.h uses it.

Thu Mar  2 12:29:50 1995  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in (ISODELIB): Remove reference to $(ISODELIB).

Wed Mar  1 11:55:15 1995  Theodore Y. Ts'o  <tytso@dcl>

	* configure.in: Remove ISODE_INCLUDE, replace check for -lsocket
		and -lnsl with WITH_NETLIB check.

Fri Feb  3 06:21:02 1995  Theodore Y. Ts'o  (tytso@dcl)

	* gss-server.c: ret_flags should be an int based on the prototype
		of gss_accept_sec_context.

Wed Oct 19 12:32:41 1994  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: Obey CCOPTS in CFLAGS declaration

Wed Oct 12 02:29:38 1994  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: Add OBJS definition so that object files get
		cleaned out during a "make clean".

Thu Sep 29 22:50:48 1994  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: Relink executables if libraries change

Thu Aug  4 13:24:29 1994  Tom Yu  (tlyu@dragons-lair)

	* configure.in: fix make install

Thu Jul 21 01:02:28 1994  Tom Yu  (tlyu at dragons-lair)

	* Makefile.in: fix infinite recursion in rules
	* gss-client.c:
	* gss-misc.c:
	* gss-server.c: downgrade to K&R function definitions

Tue Jul 19 20:28:46 1994  Tom Yu  (tlyu at dragons-lair)

	* Makefile.in:
	* configre.in: changes to make autoconf work

